<?php

# This is the command wrapper for this program. It sends commands
# to the localhost on port 15428, and talks to the remote_admin_server
# process.
function send_command($cmd)
  {
  $fp = fsockopen("127.0.0.1", 15428 , $errno, $errstr, 5);

  if (!$fp)
    {
    print "Failure : $a $errstr ($errno)<br />\n";
    print "Server side command listener is not active.<br><br>\n";
    print "<a href=./index.php>Back to Start Page</a>";
    exit;
    }
  else
    {
    $out = "$cmd\n";
    fwrite($fp, $out);
    fclose($fp);
    }
  }

# This command waits for the lockfile to be removed before returning
# the HTML. This is to prevent more than one process being started
function wait_for_lock()
  {
  # wait 250 milliseconds to make sure that the command has been started
  usleep(250000);
  while (file_exists("/tmp/php_lock") == TRUE)
    {
    usleep(100000);
    clearstatcache();
    }
  }	

# Grabs the IP of the person running the script
$ip = $_SERVER['REMOTE_ADDR']; 


# Parses the environment file to pull info such as 
# stationID and callsign.
if ($data = file('/home/irlp/custom/environment'))
  {
  for($x = 0; $x < count($data); $x++)
    {
    $pos = strpos($data[$x],'#');
    if ($pos === false)
      {
      $parts = explode('=',$data[$x]);
	if ( count($parts)<2 )
		continue;
      $part1 = trim($parts[0]);
      $part2 = trim($parts[1]);
      if (strpos($part1,"STATIONID"))
        {
        $mynodeid = $part2;
        }
      if (strpos($part1,"CALLSIGN"))
        {
        $mycallsign = $part2;
        }
      }
    }
  }
else
  {
  print "<html>\n<body>\n";
  print "<h2>ERROR - Can not access Environment file</h2>\n";
  print "</body>\n</html>\n";
  exit;
  }

# Adds a zero to old node numbers
if (strlen($mynodeid) == 6)
  {
  $mynodeid = $mynodeid."0";
  }

# read data in.
$form['display_msg'] = "";
$form['msg_lines'] = "";
$form['disable'] = "";
$form['enable'] = "";
$form['end_call'] = "";
$form['refresh'] = "";
$form['remote_call'] = "";
$form['ipaddr'] = "";
$form['codec'] = "";
$form['dtmf_script'] = "";
$form['dtmf_regen'] = "";
$form['dtmf'] = "";
$form['dtmf_r'] = "";

#print_r($_REQUEST);
foreach ($_REQUEST as $name=>$value)
 {
  chop ($name);
  $form[$name] = $value;
  # This is a great line for debugging problems
  # print "$name = $value<br>\n";
 }
#print_r($form);

# Make sure all variables being passed between sections are defined here.

$display_msg = $form['display_msg'];
$msg_lines = $form['msg_lines'];
$disable = $form['disable'];
$enable = $form['enable'];
$end_call = $form['end_call'];
$refresh = $form['refresh'];
$remote_call = $form['remote_call'];
$ipaddr = $form['ipaddr'];
$codec = $form['codec'];
$dtmf_script = $form['dtmf_script'];
$dtmf_regen = $form['dtmf_regen'];
$dtmf = $form['dtmf'];
$dtmf_r = $form['dtmf_r'];

# Play wav file 
#if ($wavplay == "Submit")
#  {
#  send_command("wavplay $wavfile");
#  wait_for_lock();
#  }
   
if ($dtmf_script == "Submit")
  {
  # Clean up the DTMF, and make sure only valid characters exist
  $dtmf = str_replace("*","S",$dtmf);  
  $dtmf = str_replace("#","P",$dtmf);  
  $dtmf = strtoupper($dtmf);
  $i = 0;
  while ($i < strlen($dtmf))
    {
    if (strpos ("1234567890ABCDSP", $dtmf[$i]) === FALSE)
      {
      print "<html>\n<body>\n";
      print "<h2>ERROR - $dtmf[$i] is not a valid DTMF character.</h2>\n";
      print "</html>\n</body>\n";
      exit;
      }
    $i++;
    }
  send_command("dtmf $dtmf");
  wait_for_lock();
  }

if ($dtmf_regen == "Submit")
  {
  # Clean up the DTMF, and make sure only valid characters exist
  $dtmf_r = str_replace("*","S",$dtmf_r);
  $dtmf_r = str_replace("#","P",$dtmf_r);
  $dtmf_r = strtoupper($dtmf_r);
  $i = 0;
  while ($i < strlen($dtmf_r))
    {
    if (strpos ("1234567890ABCDSP", $dtmf_r[$i]) === FALSE)
      {
      print "<html>\n<body>\n";
      print "<h2>ERROR - $dtmf_r[$i] is not a valid DTMF character.</h2>\n";
      print "</html>\n</body>\n";
      exit;
      }
    $i++;
    }
  send_command("dtmf_r $dtmf_r");
  wait_for_lock();
  }

if ($enable == "Enable")
  {
  send_command("enable");
  wait_for_lock();
  }

if ($disable == "Disable")
  {
  send_command("disable");
  wait_for_lock();
  }

if ($end_call == "End Call")
  {
  send_command("end");
  wait_for_lock();
  }

if ($remote_call == "Submit")
  {
  send_command("remote $ipaddr $codec");
  usleep(250000);
  wait_for_lock();
  }

if ($display_msg == "Submit")
  {
  if (is_numeric ($msg_lines) === TRUE)
    {
    system ("tail -$msg_lines /home/irlp/log/messages > /tmp/output");
    }
  else
    {
    print "<html>\n<body>\n";
    print "<h2>ERROR - $msg_lines is not a valid number of lines.</h2>\n";
    print "</html>\n</body>\n";
    exit;
    }
  }
$enable_button = "";
$disable_button = "";
$end_button = "";
$remote_button = "";

if (file_exists("/home/irlp/local/enable"))
  {
  $status = "<font color=green>ENABLED</font>";
  $enable_button = "disabled";
  }
else
  {
  $status = "<font color=red>DISABLED</font>";
  $disable_button = "disabled";
  $end_button = "disabled";
  $remote_button = "disabled";
  }

if (file_exists("/home/irlp/local/active"))
  {
  $patterns[0] = "/REF/";
  $patterns[1] = "/STN/";
  $patterns[2] = "/ref/";
  $patterns[3] = "/stn/";  
  $replacements[0] = " Reflector ";
  $replacements[1] = " Node ";
  $replacements[2] = " Reflector ";
  $replacements[3] = " Node ";
  $fh = fopen("/home/irlp/local/active", 'r');
  $connected_to_nocolor = fread($fh, filesize("/home/irlp/local/active"));
  $connected_to_nocolor = strtoupper($connected_to_nocolor);
  $connected_to_nocolor = preg_replace($patterns, $replacements, $connected_to_nocolor);
  $connected_to = "<font color=red>$connected_to_nocolor</font>";
  $remote_button = "disabled";
  }
else
  {
  $connected_to = "<font color=blue>IDLE</font>";
  $end_button = "disabled";
  }

print "<html>\n<body>\n";
print "<font face=Arial size=2>\n";

print "<form name=REFRESH method=POST action='./index.php'>\n";
print "<h3>Admin and Control Page</h3>\n";
print "<h4>$mynodeid - ($mycallsign)\n";
print "<input name=refresh tabindex=50 TYPE=SUBMIT Value=Refresh></form></h4>\n";

print "<form name=MAIN1 method=POST action='./index.php'><br>\n";
print "Node Status - <b>$status</b><br>\n";
print "Current Connection - <b>$connected_to</b><br>\n";
print "<input name=disable $disable_button tabindex=50 TYPE=SUBMIT Value=Disable>&nbsp&nbsp\n";
print "<input name=enable $enable_button tabindex=49 TYPE=SUBMIT Value=Enable>&nbsp&nbsp\n";
print "<input name=end_call $end_button tabindex=48 TYPE=SUBMIT Value='End Call'></form>\n";

print "<form name=MAIN2 method=POST action='./index.php'>\n";
print "<input type=hidden name=remote_call value=Submit><br>\n";
print "<b>Desktop Call:</b><br> <INPUT TYPE=text NAME=ipaddr VALUE=$ip SIZE=10>\n";
print "<br><input type=radio name=codec value=GSM> GSM\n";
print "<input type=radio name=codec value=ADPCM checked> ADPCM\n";
print "<input name=remote_call $remote_button tabindex=47 TYPE=SUBMIT Value=Submit></form><br>\n";

print "<form name=MAIN3 method=POST action='./index.php'>\n";
print "<input type=hidden name=dtmf_script value=Submit>\n";
print "<b>DTMF Script:</b><br> <INPUT TYPE=text NAME=dtmf SIZE=10>\n";
print "<input name=dtmf_script tabindex=40 TYPE=SUBMIT Value=Submit></form><br>\n";

print "<form name=MAIN32 method=POST action='./index.php'>\n";
print "<input type=hidden name=dtmf_regen value=Submit>\n";
print "<b>DTMF Regen:</b><br> <INPUT TYPE=text NAME=dtmf_r SIZE=10>\n";
print "<input name=dtmf_regen tabindex=39 TYPE=SUBMIT Value=Submit></form><br>\n";

print "<form name=MAIN4 method=POST action='./index.php'>\n";
print "<input type=hidden name=display_msg value=Submit>\n";
print "<b>Display messages file:</b><br><INPUT TYPE=text NAME=msg_lines VALUE=20 SIZE=4> lines\n";
print "<input name=display_msg tabindex=1 TYPE=SUBMIT Value=Submit></form><br>\n";

#$edit_button = "";
#if (`whoami` != "repeater\n")
#{
#  print "File edit option only available when apache is running as user repeater.<br>\n";
#  $edit_button = "disabled";
# }
  
print "<form action=edit.php method=post name=select>\n";
print "<select name=file>\n";
print "<option value=/home/irlp/custom/environment>Environment File</option>\n";
print "<option value=/home/irlp/custom/custom_decode>Custom Decode</option>\n";
if (file_exists("/home/irlp/features/features.env"))
  print "<option value=/home/irlp/features/features.env>Embedded features.env</option>\n";
if (file_exists("/home/irlp/custom/timeoutvalue"))
  print "<option value=/home/irlp/custom/timeoutvalue>Timeout</option>\n";
if (file_exists("/home/irlp/custom/timing"))
  print "<option value=/home/irlp/custom/timing>Timing</option>\n";
if (file_exists("/home/irlp/custom/custom_on"))
  print "<option value=/home/irlp/custom/custom_on>Custom_ON</option>\n";
if (file_exists("/home/irlp/custom/custom_off"))
  print "<option value=/home/irlp/custom/custom_off>Custom_OFF</option>\n";
if (file_exists("/home/irlp/custom/lockout_list"))
  print "<option value=/home/irlp/custom/lockout_list>Lockout List</option>\n";
if (file_exists("/home/irlp/custom/custom.crons"))
  print "<option value=/home/irlp/custom/custom.crons>Custom Crontabs</option>\n";
print "</select><input name=Submit type=submit value=\"Edit File\"></form>\n";
if ( file_exists( "/tmp/output" ) )
{
	$output_array = file("/tmp/output");
	print "<h4> ----- OUTPUT ----- </h4>\n";
	print "<font size=1>";

	foreach($output_array as $row)
	  {
	  print "$row <br>";
	  }
}
print "</font></font>\n</body>\n</html>";
?>
